/* DownloadURL - hades.manager.DownloadURL
 *
 * download a ZIP file from a webserver and list its contents
 *
 * 28.02.01
 */

package hades.manager;

import java.io.*;
import java.net.URL;
import java.util.zip.*;


class DownloadURL {

  public static void usage() {
    System.out.println( "Usage: java DownloadURL urlname filename" );
    System.exit( 0 );
  }

  public static void main( String argv[] ) throws Exception 
  {
    if (argv.length != 2) usage();

    String urlname = argv[0];
    String filename = argv[1];

    OutputStream fos = new BufferedOutputStream(
                         new FileOutputStream( filename ));
    URL  url = new URL( urlname );
    ZipInputStream ZIS = new ZipInputStream( 
                           new BufferedInputStream(
                             url.openConnection().getInputStream() ));

    while (ZIS.available() != 0) {
       ZipEntry tmp = ZIS.getNextEntry();
       if (tmp == null) break;
       System.out.println( "..." + tmp );
   }

   ZIS.close();
 }

/*

    byte buffer[] = new byte[4096];
    int length =0, count = 0;
    while( (length = IS.read( buffer, 0, buffer.length )) >= 0) {
      // System.out.println( "writing " + length + " bytes..." );
      fos.write( buffer, 0, length );
      count += length;
      System.out.println( "... " + count );
    }
    fos.close();
    System.out.println( "downloaded " + count + " bytes." );
  } 
*/

}
