/* TreePane.java - hades.manager.TreePane
 *
 * Swing Pane with the TreeView of the Components
 *
 * 27.02.01 - integration into Hades 0.87, FNH
 * 01.07.98 - original version
 * @author    Ulrich Dallmann       (2dallman@informatik.uni-hamburg.de)
 * @author    Karola Kroenert       (2kroene@informatik.uni-hamburg.de
 */
package hades.manager;

import java.awt.*;

import javax.swing.*;
import javax.swing.tree.*;



public class TreeDemo
{

  public static void createTree( JTree tree )
  {
    // Create tree from top node and do some customizing
    // large model for performance
    //tree.setLargeModel(true);

    // do not show root
    tree.setRootVisible(false);

    // set TreeCellRenderer (used to draw nodes)
tree.setCellRenderer(new HadesTreeCellRenderer());
tree.putClientProperty("JTree.lineStyle", "Angled");

    // how many Components can be selected at one time?
    DefaultTreeSelectionModel dtsm = new DefaultTreeSelectionModel();
    dtsm.setSelectionMode(DefaultTreeSelectionModel.SINGLE_TREE_SELECTION);
    tree.setSelectionModel(dtsm);

    //tree.setModel( new DefaultTreeModel(new TNode(null, null)));
    //TreeLoader tl = new TreeLoader();
    //tl.treepane = this;
    //tl.start();
    //updateTree();
  }


  /**
   * TreePane selftest
   */
  public static void main( String argv[] ) {

    JTree    tree     = new JTree();

    DefaultMutableTreeNode root = new DefaultMutableTreeNode( "root" );
    for( int i=0; i < 10; i++ ) {
      DefaultMutableTreeNode tmp = new DefaultMutableTreeNode( "level_"+i );
      root.add( tmp );
      for( int j=0; j < 7; j++ ) {
        DefaultMutableTreeNode tmp2
           = new DefaultMutableTreeNode( "sublevel_"+j );
        tmp.add( tmp2 );
        for( int k=0; k < 9; k++ ) {
          DefaultMutableTreeNode tmp3 
            = new DefaultMutableTreeNode( "subsublevel_"+k );
          tmp2.add( tmp3 );
        }
      }
    }
    tree.setModel( new DefaultTreeModel( root ));

    createTree( tree );

    JScrollPane scroller = new JScrollPane( tree );

    Frame frame = new Frame( "TreePane selftest" );
    frame.add( "Center", scroller );
    frame.setSize( 300, 700 );
    frame.show();

    TreePopupMenu popup = new TreePopupMenu( tree );
  }  
}

