/* AssemblerFileTreeNode - hades.manager.tree.AssemblerFileTreeNode
 *
 * tree node for text files in Colibri
 *
 * 04.03.01 - handleTreeSelection
 * 01.03.01 - first version
 */

package hades.manager.tree;

import javax.swing.ImageIcon;
import hades.manager.*;


/**
 * AssemblerFileTreeNode: represent assembly source files (.asm) in the
 * browser tree.
 */
public class  AssemblerFileTreeNode
       extends  SortedTreeNode {


  static ImageIcon _icon = loadIcon( "/hades/manager/icons/text.gif" );

  public ImageIcon getIcon() {
    return _icon;
  }


  /**
   * set the Browser imageCanvas icon to null.
   * load the assembler file as a text file and 
   * display in the Browser InfoPanel
   */
  public void handleTreeSelection( BrowserFrame browser ) {
    msg( "-#- AssemblerFileTN.handleTreeSelection: " + toString() );

    browser.setThumbnail( null );

    // FIXME: should load and parse ComponentInfo CLB
    InfoPanel ip = browser.getInfoPanel();
    ip.setName( toString() );
    ip.setAuthor( "-" );
    ip.setVersion( "-" );
    ip.setInfoText( 
      DesignManager.getDesignManager().readStreamIntoString(
        TreeManager.getFullPathname( this )));

  }


}
