/* DirectoryTreeNode - hades.manager.tree.DirectoryTreeNode
 *
 * the root node for a directory in the Colibri tree
 *
 * 04.03.01 - handleTreeSelection
 * 01.03.01 - first version
 */

package hades.manager.tree;

import javax.swing.ImageIcon;
import hades.manager.*;


/**
 * DirectoryTreeNode: represents a directory in the browser tree.
 */
public class  DirectoryTreeNode
       extends  SortedTreeNode {


  static ImageIcon _icon = loadIcon( "/hades/manager/icons/collapsed.gif" );

  public ImageIcon getIcon() {
    return _icon;
  }

  /**
   * set null infos to Browser imageCanvas and InfoPanel
   */
  public void handleTreeSelection( BrowserFrame browser ) {
    msg( "-#- DirectoryTN.handleTreeSelection: " + toString() );

    browser.setThumbnail( null );
    InfoPanel ip = browser.getInfoPanel();
    ip.setName( "-" );
    ip.setAuthor( "-" );
    ip.setVersion( "-" );
    ip.setInfoText( "" );
  }



}
