/* PythonFileTreeNode - hades.manager.tree.PythonFileTreeNode
 *
 * tree node for python script source files in Colibri
 *
 * 04.03.01 - first version, handleTreeSelection
 */

package hades.manager.tree;

import javax.swing.ImageIcon;
import hades.manager.*;


/**
 * PythonFileTreeNode: represent a Python source file in the browser tree.
 */
public class  PythonFileTreeNode
       extends  SortedTreeNode {


  static ImageIcon _icon = loadIcon( "/hades/manager/icons/python.gif" );

  public ImageIcon getIcon() {
    return _icon;
  }


  /**
   * set the Browser imageCanvas icon to null.
   * load the text file and 
   * display in the Browser InfoPanel
   */
  public void handleTreeSelection( BrowserFrame browser ) {
    msg( "-#- PythonFileTN.handleTreeSelection: " + toString() );

    browser.setThumbnail( null );

    // FIXME: should load and parse ComponentInfo CLB
    InfoPanel ip = browser.getInfoPanel();
    ip.setName( toString() );
    ip.setAuthor( "-" );
    ip.setVersion( "-" );
    ip.setInfoText( 
      DesignManager.getDesignManager().readStreamIntoString(
        TreeManager.getFullPathname( this )));

  }


}
