/* ReadmeFileTreeNode - hades.manager.tree.ReadmeFileTreeNode
 *
 * tree node for text files in Colibri
 *
 * 04.03.01 - first version
 */

package hades.manager.tree;

import javax.swing.ImageIcon;
import hades.manager.*;


/**
 * ReadmeFileTreeNode: represent "README" text files in the browser tree.
 */
public class  ReadmeFileTreeNode
       extends  SortedTreeNode {


  static ImageIcon _icon = loadIcon( "/hades/manager/icons/readme.gif" );

  public ImageIcon getIcon() {
    return _icon;
  }


  /**
   * base mehtod for all action necessary, when this node is selected
   * in the Colibri tree control.
   */
  public void handleTreeSelection( BrowserFrame browser ) {
    msg( "-#- ReadmeFileTN.handleTreeSelection: " + toString() );

    browser.setThumbnail( null );

    // FIXME: should load and parse ComponentInfo CLB
    InfoPanel ip = browser.getInfoPanel();
    ip.setName( "README" );
    ip.setAuthor( "-" );
    ip.setVersion( "-" );
    ip.setInfoText( 
      DesignManager.getDesignManager().readStreamIntoString(
        TreeManager.getFullPathname( this )));
  }


}
